;Mini-Shell by Chicane
;version .9
;16 bytes of optimizations by Dark Ryder
#include "asm86.h"
#include "ti86asm.inc"
#include "ti86ops.inc"

_MOV10TOOP1     		equ     $42D7	;Move 10bytes a hl to OP1
_MOV10TOOP2     		equ     $42DF	;Move 10bytes a hl to OP1
_cpOP1OP2               equ     $41fb   ;compare OP1 to OP2
_homeup         		equ     $4A95	;resets _curRow etc.
_dispahl                equ     $4a33	;displays ahl decimal
_get_word_ahl			equ		$521d
_pop_OP1 				equ 	$47B7
_push_OP1 				equ 	$4813
_PrevPrgm				equ		$514F
_NextPrgm				equ		$514B
_exec_basic				equ		$4C57
_exec_asm				equ		$5730
_runoff                 equ     $4AB1
_runon                  equ     $4AAD
_chkPrgm				equ		$46AB
_off                    equ     $4101

.org _asm_exec_ram

ASMstart:
	call    _runoff				;turn busy indicator off
	call    _clrScrn			;clear the screen

Display:
	ld      hl,$0001			;duh
	ld      (_penCol), hl		;set up where to put text
	ld      hl,PrgmName			;load the text address
	call    _vputs				;output in variable width text format.
	
	ld      a,$6F			
	ld      (_penCol),a
	ld      hl,Version			;same as above
	call    _vputs
	
	ld      hl,$3919
	ld      (_penCol),hl		;blah blah
	ld      hl,EMail
	call    _vputs
	
	ld      hl,$FF90			
	call    Invert				;Draws a black bar(reverse)
	ld      hl,$FC00	
	call    Invert

DispBox:
	set		3,(iy+5)			;set reverse video mode
	ld		hl,$0301			;output the "Programs List" text
	ld		(_curRow),hl
	ld		hl,PrgmsMenu
	call	_puts
	ld		hl,$0405
	ld		(_curRow),hl
	ld		hl,System
	call	_puts
	res		3,(iy+5)			;reset reverse video mode

FreeMem:						;Free memory on calc
	ld		hl,$0506			;place to put text
	ld		(_curRow),hl		;load it in
	call	_MEMCHK   			;the actual check
	call	_dispahl			;Display the number of bytes
	ld		hl,ByteString		;add "bytes free" after number
	call	_puts				;put it to screen

FirstPrgm:
	ld		hl,AbsFirst			;Load address of the first posible program name into hl
	rst		20h					;Move 10 bytes at hl to OP1
	xor		a					;clear a
 	call	_NextPrgm			;Find Next Program Variable
	call	_NextPrgm			;do it again
	jr		c,NoPrgms			;If 2 programs are not found (minishel + 1 other) then exit w/msg
	call	PrevPrgm

GetKey1:						;Key Check Routine
	call    _getkey				;Gets last key pressed
	cp      kExit
	jp      z,Exit
	cp      kUp
	call    z,PrevPrgm
	cp      kDown
	call    z,NextPrgm
	cp      kClear
	jr      z,ShutOff
	cp		kEnter
	jr		z,Exec
	cp		kDel
	jr		z,Delete
	jr      GetKey1

;<-------Utility Routines---------->
NoPrgms:						;Tells you that you dont have any programs except minishel
	call	_clrScrn			;clear somthing
	call	_homeup				;reset _curRow etc
	ld		hl,NoProgs			;load the string into hl
	call	_puts				;output it
	ret							;exit to ti-os

Restart:
	jp		ASMstart

ShutOff:						;shut off routine
	res 	3,(iy+8)			;Lock the APD		
	set 	4,(iy+8)			;Expire APD
	call 	_off				;Turn It Off
	jr      GetKey1 			;Restart

Exec:
	rst		10h					;find the address of the program in OP1
	call	_chkPrgm			;check for asm of basic
	jr		nz,ExecBasic		;if basic, jump down
	call	_exec_asm 			;else, exec it.
	xor		a					;clear a
	jr		Restart				;restart

ExecBasic:
	call	_runon				;turn busy indicator on
	call	_exec_basic			;exececute basic program
	jr		Restart				;restart

Delete:							;Delete current program
	rst		10h					;find address
	call	_delvar				;delete it
	xor		a					;clear a
	jr		Restart 			;restart

Invert:							;Inverts a 7 line place on the screen.
	ld      bc,112				;written by Andreas Ess
InvertLoop:
	ld      a,(hl)
	cpl
	ld      (hl),a
	inc     hl
	dec     bc
	ld      a,b
	or      c
	jr      nz,InvertLoop
	ret

PrevPrgm:						;Finds the Previous program in the VAT
	xor		a					;clear a
	call	_PrevPrgm			;the actuall call
	xor		a					;clear it again
	ret		c					;return if no more found
	ld		hl,MiniShell		;load the VAT Entry of Mini-Shell into hl
	call	_MOV10TOOP2			;move it to op2
	call	_cpOP1OP2			;compare Mini-Shell to op1
	jr		z,FoundMini1		;Jump to FoundMini1 if they are the same
	jr		DisplayP			;else Display the program

FoundMini1:						;skips minishell
	xor		a					;clear a
	call	_PrevPrgm			;check for program before minishell
	jr		nc,DisplayP			;diplay if one exists 
	xor		a
	call	_NextPrgm			;then find the program before minishel
	jr		DisplayP			;then display it

NextPrgm:						;Finds the next Program
	xor		a					;clear a
 	call	_NextPrgm			;opposite of $514F
	xor		a
	ret	    c					;same as above
	ld		hl,MiniShell
	call	_MOV10TOOP2
	call	_cpOP1OP2
	jr		z,FoundMini2
	jr  	DisplayP			;blah, blah

FoundMini2:
	xor		a
	call	_NextPrgm
	jr		nc,DisplayP
	xor		a
	call	_PrevPrgm
	jr		DisplayP

DisplayP:						;Display Routine
	ld		hl,$0302			;place to start text
	ld		(_curRow),hl		;load it into _penCol
	ld		hl,_OP1+2			;what to display
	call	_puts				;output to screen
	ld		hl,ClearLine		;add spaces to end to cover up previous program if was a longer name
	call	_puts				;output
	ld		hl,$0D02
	ld		(_curRow),hl
	call	_push_OP1
	rst 	10h					;find address of program in op1
	ld 		a,b					;
	ex		de,hl
	call 	_get_word_ahl		;Get program length
	ex		de,hl
	xor		a					;clear a
	call	_dispahl			;display hl (a is 0 so it wont show)
	call	_pop_OP1			;pop op1
	ret

Exit:							;Exit minishell
	jp 		_clrScrn			;clear it again

;<------------ Strings used in program-------------->

ByteString:
	.db " bytes",0

NoProgs:
	.db "No Prgms!",0
System:
	.db "  Free  Mem  ",0
PrgmsMenu:
	.db " Program  Size ",0

AbsFirst:
	.db $12,$01,$00

MiniShell:
	.db $12,$08,"minishel",$00,0

ClearLine:
	.db $00,$00,$00,$00,$00,$00,$00,0

EMail:  
	.db "chicane@reninet.com",0

PrgmName:
	.db "Mini-Shell",0

Version:
	.db "v.9",0
.end

